﻿#pragma once

#include <string>
#include "..\Common\DeviceResources.h"
#include "..\Common\StepTimer.h"

namespace BitmapTransformExperiment
{
    class BitmapTransformExperimentRenderer
    {
    public:
        BitmapTransformExperimentRenderer(const std::shared_ptr<DX::DeviceResources>& deviceResources);
        void CreateDeviceDependentResources();
        void ReleaseDeviceDependentResources();
        void CreateWindowSizeDependentResources();
        void Update(DX::StepTimer const& timer);
        bool Render();

        void MatrixValueChanged(Windows::Foundation::Collections::IVector<float>^ matrix);

    private:
        // Cached pointer to device resources.
        std::shared_ptr<DX::DeviceResources> m_deviceResources;
        bool                                 m_needsRedraw;

        // Bitmap and transform matrix
        Microsoft::WRL::ComPtr<ID2D1Bitmap>     m_bitmap;
        D2D1_MATRIX_4X4_F                       m_matrix;

        Microsoft::WRL::ComPtr<ID2D1DrawingStateBlock>  m_stateBlock;
        Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_axisBrush;
    };
}