﻿//
// InputMatrix4x4F.xaml.cpp
// Implementation of the InputMatrix4x4F class
//

#include "pch.h"
#include "InputMatrix4x4F.xaml.h"
#include "Spinner.xaml.h"

using namespace BitmapTransformExperiment;

using namespace Platform;
using namespace Platform::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls::Primitives;

InputMatrix4x4F::InputMatrix4x4F()
{
    InitializeComponent();
    OnResetButtonClick(nullptr, nullptr);
}

void InputMatrix4x4F::OnSpinnerValueChanged(Object^ sender, RangeBaseValueChangedEventArgs^ args)
{
    Spinner^ spinner = safe_cast<Spinner^>(sender);
    String^ tag = safe_cast<String^>(spinner->Tag);
    const wchar_t * tagChars = tag->Data();
    int row = tagChars[0] - '1';
    int col = tagChars[1] - '1';
    m_matrix[row][col] = float(args->NewValue);

    ValueChanged(this, ref new Vector<float>((float *)m_matrix, 16));
}

void InputMatrix4x4F::OnResetButtonClick(Object^ sender, RoutedEventArgs^ args)
{
    for (int row = 0; row < 4; row++)
    for (int col = 0; col < 4; col++)
    {
        m_matrix[row][col] = row == col ? 1.0f : 0.0f;
        safe_cast<Spinner^>(FindName("m" + (row + 1) + (col + 1)))->Value = m_matrix[row][col];
    }
}
