﻿//
// Spinner.xaml.cpp
// Implementation of the Spinner class
//

#include "pch.h"
#include "Spinner.xaml.h"

using namespace BitmapTransformExperiment;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

Spinner::Spinner()
{
    InitializeComponent();

    Loaded += ref new RoutedEventHandler([this](Object^, Object^)
    {
        FormatValue(float(this->Value));
    });
}

void Spinner::OnApplyTemplate()
{
    txtblk = dynamic_cast<TextBlock^>(GetTemplateChild("txtblk"));
}

void Spinner::OnValueChanged(double oldValue, double newValue)
{
    FormatValue(float(newValue));

    RangeBase::OnValueChanged(oldValue, newValue);
}

void Spinner::FormatValue(float number)
{
    if (txtblk != nullptr)
    {
        int decimals = -int(log10(float(this->SmallChange)));
        txtblk->Text = FormatValue(number, decimals);
    }
}

String^ Spinner::FormatValue(float number, int decimals)
{
    wchar_t str[16];
    swprintf(str, sizeof(str) / sizeof(str[0]), L"%.*f", decimals, number);
    return ref new String(str);
}

void Spinner::OnUpButtonClick(Object^ sender, RoutedEventArgs^ args)
{
    this->Value = min(this->Maximum, this->Value + this->SmallChange);
}

void Spinner::OnDownButtonClick(Object^ sender, RoutedEventArgs^ args)
{
    this->Value = max(this->Minimum, this->Value - this->SmallChange);
}
