﻿//
// DisplayMatrix4x4F.xaml.cpp
// Implementation of the DisplayMatrix4x4F class
//

#include "pch.h"
#include "DisplayMatrix4x4F.xaml.h"

using namespace NonAffineStretch;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Core;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;

DisplayMatrix4x4F::DisplayMatrix4x4F()
{
    InitializeComponent();
}

void DisplayMatrix4x4F::SetMatrix(const Array<float>^ matrix)
{
    this->Dispatcher->RunAsync(CoreDispatcherPriority::Normal, 
                               ref new DispatchedHandler([this, matrix]()
    {
        FormatAll(matrix);
    }));
}

void DisplayMatrix4x4F::FormatAll(const Array<float>^ matrix)
{
    m11->Text = Format(matrix[0], 3);
    m12->Text = Format(matrix[1], 3);
    m13->Text = Format(matrix[2], 3);
    m14->Text = Format(matrix[3], 6);

    m21->Text = Format(matrix[4], 3);
    m22->Text = Format(matrix[5], 3);
    m23->Text = Format(matrix[6], 3);
    m24->Text = Format(matrix[7], 6);

    m31->Text = Format(matrix[8], 3);
    m32->Text = Format(matrix[9], 3);
    m33->Text = Format(matrix[10], 3);
    m34->Text = Format(matrix[11], 6);

    m41->Text = Format(matrix[12], 0);
    m42->Text = Format(matrix[13], 0);
    m43->Text = Format(matrix[14], 0);
    m44->Text = Format(matrix[15], 0);
}

String^ DisplayMatrix4x4F::Format(float number, int decimals)
{
    wchar_t str[16];
    swprintf(str, sizeof(str) / sizeof(str[0]), L"%.*f", decimals, number);
    return ref new String(str);
}