﻿#pragma once

#include <string>
#include "..\Common\DeviceResources.h"
#include "..\Common\StepTimer.h"

namespace RotatingText
{
    class RotatingTextRenderer
    {
    public:
        RotatingTextRenderer(const std::shared_ptr<DX::DeviceResources>& deviceResources);
        void CreateDeviceDependentResources();
        void ReleaseDeviceDependentResources();
        void CreateWindowSizeDependentResources();
        void Update(DX::StepTimer const& timer);
        void Render();

    private:
        // Cached pointer to device resources.
        std::shared_ptr<DX::DeviceResources> m_deviceResources;
        Microsoft::WRL::ComPtr<ID2D1DrawingStateBlock>  m_stateBlock;

        // Bitmap and matrix for rotating text
        Microsoft::WRL::ComPtr<ID2D1Bitmap> m_bitmap;
        D2D1::Matrix4x4F                    m_matrix;
    };
}